diff mbox

btrfs-progs: misc-tests: Primary Superblock corruption and recovery using backup Superblock.

Message ID 20170214213125.GA25514@giis.co.in (mailing list archive)
State New, archived
Headers show

Commit Message

Lakshmipathi.G Feb. 14, 2017, 9:31 p.m. UTC
Signed-off-by: Lakshmipathi.G <Lakshmipathi.G@giis.co.in>
---
 .../019-fix-corrupted-superblock/test.sh           | 37 ++++++++++++++++++++++
 1 file changed, 37 insertions(+)
 create mode 100755 tests/misc-tests/019-fix-corrupted-superblock/test.sh

Comments

Lakshmipathi.G Feb. 15, 2017, 9:14 a.m. UTC | #1
On Wed, Feb 15, 2017 at 09:36:03AM +0800, Qu Wenruo wrote:
> 
> 
> >+	# Corrupt superblock checksum
> >+        dd if=/dev/zero of=$TEST_DEV seek=$superblock_offset bs=1 \
> >+        count=4  conv=notrunc &> /dev/null
> >+	run_check_stdout $SUDO_HELPER mount $TEST_DEV $TEST_MNT | \
> >+	grep -q 'wrong fs type'
> 
> What about using btrfs check instead of trying to mount it?
> 
> This could emit the need to use $SUDO_HELPER, and could catch super error
> more accurate.
> 
> >+        if [ $? -ne 0 ]; then
> >+		_fail "Failed to corrupt superblock."
> >+        fi
> >+
> >+	# Copy backup superblock to primary
> >+	run_check $TOP/btrfs-select-super -s 1 $TEST_DEV
> >+	run_check $SUDO_HELPER mount $TEST_DEV $TEST_MNT
> Same here.
I started with 'btrfs check' and 'btrfs check --repair' but it seems like
--repair don't fix the corruption. So just moved away from using it.

After you mentioned, now I see 'btrfs check' will be helpful. Will make
these changes. 

Cheers.
Lakshmipathi.G
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
David Sterba March 13, 2017, 5:22 p.m. UTC | #2
On Wed, Feb 15, 2017 at 02:44:05PM +0530, Lakshmipathi.G wrote:
> On Wed, Feb 15, 2017 at 09:36:03AM +0800, Qu Wenruo wrote:
> > 
> > 
> > >+	# Corrupt superblock checksum
> > >+        dd if=/dev/zero of=$TEST_DEV seek=$superblock_offset bs=1 \
> > >+        count=4  conv=notrunc &> /dev/null
> > >+	run_check_stdout $SUDO_HELPER mount $TEST_DEV $TEST_MNT | \
> > >+	grep -q 'wrong fs type'
> > 
> > What about using btrfs check instead of trying to mount it?
> > 
> > This could emit the need to use $SUDO_HELPER, and could catch super error
> > more accurate.
> > 
> > >+        if [ $? -ne 0 ]; then
> > >+		_fail "Failed to corrupt superblock."
> > >+        fi
> > >+
> > >+	# Copy backup superblock to primary
> > >+	run_check $TOP/btrfs-select-super -s 1 $TEST_DEV
> > >+	run_check $SUDO_HELPER mount $TEST_DEV $TEST_MNT
> > Same here.
> I started with 'btrfs check' and 'btrfs check --repair' but it seems like
> --repair don't fix the corruption. So just moved away from using it.

Check --repair will not fix the superblock checksum as it's not clear
whether the rest of the superblock is ok or not.
--
To unsubscribe from this list: send the line "unsubscribe linux-btrfs" in
the body of a message to majordomo@vger.kernel.org
More majordomo info at  http://vger.kernel.org/majordomo-info.html
diff mbox

Patch

diff --git a/tests/misc-tests/019-fix-corrupted-superblock/test.sh b/tests/misc-tests/019-fix-corrupted-superblock/test.sh
new file mode 100755
index 0000000..806c775
--- /dev/null
+++ b/tests/misc-tests/019-fix-corrupted-superblock/test.sh
@@ -0,0 +1,37 @@ 
+#!/bin/bash
+#
+# Corrupt primary superblock and restore it using backup superblock.
+#
+
+source $TOP/tests/common
+
+check_prereq btrfs-select-super
+
+setup_root_helper
+prepare_test_dev 512M
+
+superblock_offset=65536
+
+test_superblock_restore()
+{
+	run_check $SUDO_HELPER $TOP/mkfs.btrfs -f $TEST_DEV
+
+	# Corrupt superblock checksum
+        dd if=/dev/zero of=$TEST_DEV seek=$superblock_offset bs=1 \
+        count=4  conv=notrunc &> /dev/null
+	run_check_stdout $SUDO_HELPER mount $TEST_DEV $TEST_MNT | \
+	grep -q 'wrong fs type'
+        if [ $? -ne 0 ]; then
+		_fail "Failed to corrupt superblock."
+        fi 
+
+	# Copy backup superblock to primary
+	run_check $TOP/btrfs-select-super -s 1 $TEST_DEV
+	run_check $SUDO_HELPER mount $TEST_DEV $TEST_MNT
+        if [ $? -ne 0 ]; then
+		_fail "Failed to fix superblock."
+        fi 
+	run_check_umount_test_dev
+}
+
+test_superblock_restore